proc helpmsg {} {
    if {[winfo exists .hlp]} {
        focus .hlp
        return
    }

    toplevel .hlp

    wm title .hlp ""
    wm resizable .hlp 0 0

    canvas .hlp.c -width 700 -height 600
    grid .hlp.c

    image create photo i -file [file join $::appdir helpmsg.gif]
    .hlp.c create image 2 2 -image i -anchor nw
}

proc intervals {} {
    if {[winfo exists .int]} {
        focus .int
        return
    }

    toplevel .int

    wm title .int " ̷ "
    wm resizable .int 0 0
    .int configure -padx 1 -pady 1

    text .int.t -width 80 -height 25 -font {fixed 12} -yscrollcommand ".int.s set"
    scrollbar .int.s -orient vertical -command ".int.t yview"
    grid .int.t -row 0 -column 0
    grid .int.s -row 0 -column 1 -sticky ns

    set f [open [file join $::appdir intervals.dat] r]
    .int.t insert end [read $f]
    close $f

    .int.t configure -state disabled
}

# Ҹ  ν
proc mksnd {} { 
#   õ  ȣ 迭 
    set nt {}
    for {set i 1} {$i <= 36} {incr i} {
        if {[.fc.c itemcget $i -image] != "worig" && \
                                        [.fc.c itemcget $i -image] != "borig"} {
            lappend nt $i
        }
    }

    if {$nt == {}} {return}

    snack::sound snd -rate 22050
    foreach fr $nt {
        set f [snack::filter generator \
                    [lindex $::freqs [expr $fr - 1]] [expr $::volume * 150] \
                                        $::tone sine [expr int($::len * 20000)]]
        snd play -filter $f -command "$f destroy"
    }
} 

# ǾƳ ǹ / Ѵ
proc selkey {} {
    set id [.fc.c find withtag current] 

#   ڵ̸  ư Ŭ  
#   ǹ Ŭ  ó̶...
    if {$::btnpressed} {
#        ::btnpressed ʱȭŲ
        set ::btnpressed 0
#       ǹݻ ʱȭѴ
        for {set i 1} {$i <= 36} {incr i} {
            if {[include $i $::blackkeys]} {
                .fc.c itemconfigure $i -image borig
            } else {
                .fc.c itemconfigure $i -image worig
            }
        }
#       õ ͸  Ķ ٲ۴
        if {[include $id $::blackkeys]} {
            .fc.c itemconfigure $id -image bsele
        } else {
            .fc.c itemconfigure $id -image wsele
        }
        .f1.l1 configure -text "ٸ ǥ:"
        .f1.l2 configure -text " :"
    } else {
#       ׷ ʴٸ
#       õ ǹ  Ķ,      ٲ۴
        if {[include $id $::blackkeys]} {
            if {[.fc.c itemcget $id -image] == "bsele"} {
                .fc.c itemconfigure $id -image borig
            } else {
                .fc.c itemconfigure $id -image bsele
            }
        } else {
            if {[.fc.c itemcget $id -image] == "wsele"} {
                .fc.c itemconfigure $id -image worig
            } else {
                .fc.c itemconfigure $id -image wsele
            }
        }
    }

    srchchd
}

#  迭 Ұ ٸ 迭  ӿ ԵǴ ˾ƺ
proc include {s1 s2} {
    # ԵǸ 1, Ե  0 Ѵ
    foreach s3 $s1 {
#       ҵ鳢 ġϸ  match 1 ȴ
        set match 0
        foreach s4 $s2 {
            if {$s3 == $s4} {
                set match 1
            }
        }
#       s1   s2 Ե ʴ  ߰ߵǸ 0 ش
        if {$match == 0} {
            return 0
        }
    }
#    s1 Ұ s2 ԵǸ 1 ش
    return 1
}

# شǴ ڵ带 ã ǥѴ
proc srchchd {} {
#   ڵ ̸ Ѽ Ѵ, chdno Ѱ 1 
    set chdno [expr 12 * [llength $::chdnames] -1]

#   õ  迭 , ߺǴ  迭 Ѵ
    set nt {}
    for {set i 1} {$i <= 36} {incr i} {
        if {[.fc.c itemcget $i -image] == "wsele" || [.fc.c itemcget $i -image] == "bsele" && ![include [lindex [.fc.c itemcget $i -tag] 0] $nt]} {
            lappend nt [lindex [.fc.c itemcget $i -tag] 0]
        }
    }

#   ڵ̸  ư  ʱȭѴ
    for {set i 0} {$i <= $chdno} {incr i} {
        .f1.b$i configure -bg SystemButtonFace -fg black
    }

#   õ    ٷ 
    if {$nt == {}} {
        return
    }

#    ġ  ư , κ ġ  Ķ ǥѴ
    for {set i 0} {$i <= $chdno} {incr i} {
        if {[include $nt [lindex $::notes $i]]} {
            if {[lsort $nt] == [lsort [lindex $::notes $i]]} {
                .f1.b$i configure -bg red -fg white
            } else {
                .f1.b$i configure -bg blue -fg white
            }
        }
    }
}

# õ ڵ忡 Ե  ǾƳ ǹݿ ǥѴ
proc srchnt {n r c} {
    set ::btnpressed 1

    clrchd
#   Ŭ ư   ǥѴ
    .f1.b$n configure -bg red -fg white

# ڵ ٸ ̸ ּ ܴ
    .f1.l1 configure \
        -text "ٸ ǥ: [regsub -all @ [lindex $::othernames $c] [lindex $::roots $r]]"
    .f1.l2 configure \
        -text " : [regsub -all @ [lindex $::comments $c] [lindex $::roots $r]]"

#   شǴ ǹ  Ķ ǥѴ
#   ڵ Ҹ ҷ ش Ű带 ǥ   Ҹ ʴ Ѵ
    set nt [lindex $::notes $n]
    for {set i 10} {$i <= 36} {incr i} {
        if {[.fc.c itemcget $i -tag] == [lindex $nt 0]} {
            if {[include $i $::blackkeys]} {
                .fc.c itemconfigure $i -image bsele
            } else {
                .fc.c itemconfigure $i -image wsele
            }
            set nt [lrange $nt 1 end]
        }
    }

#    ȫ ǥѴ
    set nt [lindex [lindex $::notes $n] 0]
    for {set i 10} {$i <= 36} {incr i} {
        if {[.fc.c itemcget $i -tag] == $nt} {
            if {[include $i $::blackkeys]} {
                .fc.c itemconfigure $i -image bbase
            } else {
                .fc.c itemconfigure $i -image wbase
            }
            return
        }
    }
}

# ǹݰ ڵ̸  ư  ʱȭѴ
proc clrchd {} {
#   ڵ ̸ Ѽ Ѵ, chdno Ѱ 1 
    set chdno [expr 12 * [llength $::chdnames] -1]

#   ǹݻ ʱȭѴ
    for {set i 1} {$i <= 36} {incr i} {
        if {[include $i $::blackkeys]} {
            .fc.c itemconfigure $i -image borig
        } else {
            .fc.c itemconfigure $i -image worig
        }
    }

#   ư ʱȭѴ
    for {set i 0} {$i <= $chdno} {incr i} {
        .f1.b$i configure -bg SystemButtonFace -fg black
    }

    .f1.l1 configure -text "ٸ ǥ:"
    .f1.l2 configure -text " :"
}

# Ʈ Ʈ ̹ ȯѴ
 proc str2bmp strimj {
    set width  [string length [lindex $strimj 0]]
    set height [llength $strimj]
    set bytes {}
    foreach line [string map {. 0} $strimj] {
        regsub -all {[^0]} $line 1 line ;# black pixel
        foreach bin [split [binary format b* $line] ""] {
            lappend bytes [scan $bin %c]
        }
    }
    set    res "#define i_width $width\n#define i_height $height\n"
    append res "static char i_bits\[\] = {\n[join $bytes ,]\n}"
 }

# ǹݿ   Ѵ
proc choosecolor {} {
    if {[winfo exists .top]} {
        focus .top
        return
    }

    toplevel .top
    wm title .top " ϱ"
    wm resizable .top 0 0
    .top configure -padx 20 -pady 15

    button .top.b1 -text " ǹ " -width 15 -font {fixed 10} \
                   -command {   set color [tk_chooseColor]
                                if {$color != {}} {
                                    borig configure -background $color
                                    .top.c1 configure -bg $color
                                }
                                focus .top
                            }
    button .top.b2 -text " ǹ 𼭸 " -width 15 -font {fixed 10} \
                   -command {   set color [tk_chooseColor]
                                if {$color != {}} {
                                    borig configure -foreground $color
                                    bsele configure -foreground $color
                                    bbase configure -foreground $color
                                    .top.c2 configure -bg $color
                                }
                                focus .top
                            }
    button .top.b3 -text "Ͼ ǹ " -width 15 -font {fixed 10} \
                   -command {   set color [tk_chooseColor]
                                if {$color != {}} {
                                    worig configure -background $color
                                    .top.c3 configure -bg $color
                                }
                                focus .top
                            }
    button .top.b4 -text "Ͼ ǹ 𼭸 " -width 15 -font {fixed 10} \
                   -command {   set color [tk_chooseColor]
                                if {$color != {}} {
                                    worig configure -foreground $color
                                    wsele configure -foreground $color
                                    wbase configure -foreground $color
                                    .top.c4 configure -bg $color
                                }
                                focus .top
                            }
    button .top.b5 -text "õ ǹ " -width 15 -font {fixed 10} \
                   -command {   set color [tk_chooseColor]
                                if {$color != {}} {
                                    bsele configure -background $color
                                    wsele configure -background $color
                                    .top.c5 configure -bg $color
                                }
                                focus .top
                            }
    button .top.b6 -text " ǹ " -width 15 -font {fixed 10} \
                   -command {   set color [tk_chooseColor]
                                if {$color != {}} {
                                    bbase configure -background $color
                                    wbase configure -background $color
                                    .top.c6 configure -bg $color
                                }
                                focus .top
                            }
    button .top.b7 -text "  " -width 15 -font {fixed 10} -fg blue \
        -command {saveini}
    button .top.b8 -text "⺻  θ" -width 15 -font {fixed 10} -fg blue \
        -command {loaddef}
    button .top.b9 -text "ħ" -width 15 -font {fixed 10} -fg red \
        -command {destroy .top}

    button .top.c1 -width 5 -bg [borig cget -background] -state disabled
    button .top.c2 -width 5 -bg [borig cget -foreground] -state disabled
    button .top.c3 -width 5 -bg [worig cget -background] -state disabled
    button .top.c4 -width 5 -bg [worig cget -foreground] -state disabled
    button .top.c5 -width 5 -bg [bsele cget -background] -state disabled
    button .top.c6 -width 5 -bg [bbase cget -background] -state disabled

    grid .top.c1 -row 0 -column 0 -padx 5 -pady 5 
    grid .top.c2 -row 0 -column 2 -padx 5 -pady 5 
    grid .top.c3 -row 1 -column 0 -padx 5 -pady 5 
    grid .top.c4 -row 1 -column 2 -padx 5 -pady 5 
    grid .top.c5 -row 2 -column 0 -padx 5 -pady 5 
    grid .top.c6 -row 2 -column 2 -padx 5 -pady 5 

    grid .top.b1 -row 0 -column 1 -padx 5 -pady 5 
    grid .top.b2 -row 0 -column 3 -padx 5 -pady 5 
    grid .top.b3 -row 1 -column 1 -padx 5 -pady 5 
    grid .top.b4 -row 1 -column 3 -padx 5 -pady 5 
    grid .top.b5 -row 2 -column 1 -padx 5 -pady 5 
    grid .top.b6 -row 2 -column 3 -padx 5 -pady 5 

    grid .top.b7 -row 3 -column 0 -columnspan 2 -padx 5 -pady 5 
    grid .top.b8 -row 3 -column 2 -columnspan 2 -padx 5 -pady 5 
    grid .top.b9 -row 4 -column 0 -columnspan 4 -padx 5 -pady 5 
}

# ini  ҷ´
proc loadini {} {
    set f [open [file join $::inidir chord.ini] r]
    gets $f colors
    close $f

    if {[lindex $colors 0] != "v0.92"} {return}

    set ::len [lindex $colors 1]
    set ::volume [lindex $colors 2]
    set ::tone [lindex $colors 3]

    borig configure -background [lindex $colors 4]
    borig configure -foreground [lindex $colors 5]
    bsele configure -foreground [lindex $colors 5]
    bbase configure -foreground [lindex $colors 5]
    worig configure -background [lindex $colors 6]
    worig configure -foreground [lindex $colors 7]
    wsele configure -foreground [lindex $colors 7]
    wbase configure -foreground [lindex $colors 7]
    bsele configure -background [lindex $colors 8]
    wsele configure -background [lindex $colors 8]
    bbase configure -background [lindex $colors 9]
    wbase configure -background [lindex $colors 9]
}

proc loaddef {} {
    borig configure -background gray
    borig configure -foreground white
    bsele configure -foreground white
    bbase configure -foreground white
    worig configure -background white
    worig configure -foreground black
    wsele configure -foreground black
    wbase configure -foreground black
    bsele configure -background lightblue
    wsele configure -background lightblue
    bbase configure -background pink
    wbase configure -background pink

    .top.c1 configure -bg gray
    .top.c2 configure -bg white
    .top.c3 configure -bg white
    .top.c4 configure -bg black
    .top.c5 configure -bg lightblue
    .top.c6 configure -bg pink
}

# ini  Ѵ
proc saveini {} {
    set colors "v0.92 $::len $::volume $::tone \
[borig cget -background] [borig cget -foreground] \
[worig cget -background] [worig cget -foreground] \
[bsele cget -background] [bbase cget -background]"

    set f [open [file join $::inidir chord.ini] w]
    puts $f $colors
    close $f

    tk_messageBox -message "ǹ  , ,   Ͽϴ."
    focus .top
}

#wm resizable . 1 1
wm resizable . 0 0

wm title . "ǾƳ ڵ  v0.92"
wm iconbitmap . chord.ico

package require snack

# Ʒ ּ   startkit   ʿ 
#set appdir [file join $starkit::topdir lib/app-chord]
set appdir {.}

# Ʒ ּ   startkit   ʿ 
#set inidir [file dirname $starkit::topdir]
set inidir {.}

#  notes ڵ  ԷѴ
source [file join $appdir chord.dat]

# ڵ ̸  ư   btnpressed 1 ȴ
set btnpressed 0

# ǾƳ ǹ ׸ ׸
frame .fc
grid .fc -padx 10 -pady 10
canvas .fc.c -width 631 -height 140
grid .fc.c
bind .fc.c <1> {selkey}

# ǹ ̹ bkeybmp, wkeybmp ִ´
source [file join $appdir keys-bitmaps.dat]

image create bitmap borig -data [str2bmp $bkeybmp] \
                                    -foreground white -background gray
image create bitmap bbase -data [str2bmp $bkeybmp] \
                                    -foreground white -background pink
image create bitmap bsele -data [str2bmp $bkeybmp] \
                                    -foreground white -background lightblue
image create bitmap worig -data [str2bmp $wkeybmp] \
                                    -foreground black -background white
image create bitmap wbase -data [str2bmp $wkeybmp] \
                                    -foreground black -background pink
image create bitmap wsele -data [str2bmp $wkeybmp] \
                                    -foreground black -background lightblue

foreach interval {0 210 420} {

    set x1 [expr 2 + $interval]
    set x2 [expr $x1 + 20]
    
    .fc.c create image [expr $x1 +   0] 2 -image worig -anchor nw -tag c
    .fc.c create image [expr $x2 +   0] 2 -image borig -anchor nw -tag c#
    .fc.c create image [expr $x1 +  30] 2 -image worig -anchor nw -tag d
    .fc.c create image [expr $x2 +  30] 2 -image borig -anchor nw -tag d#
    .fc.c create image [expr $x1 +  60] 2 -image worig -anchor nw -tag e
    .fc.c create image [expr $x1 +  90] 2 -image worig -anchor nw -tag f
    .fc.c create image [expr $x2 +  90] 2 -image borig -anchor nw -tag f#
    .fc.c create image [expr $x1 + 120] 2 -image worig -anchor nw -tag g
    .fc.c create image [expr $x2 + 120] 2 -image borig -anchor nw -tag g#
    .fc.c create image [expr $x1 + 150] 2 -image worig -anchor nw -tag a
    .fc.c create image [expr $x2 + 150] 2 -image borig -anchor nw -tag a#
    .fc.c create image [expr $x1 + 180] 2 -image worig -anchor nw -tag b
}

#  ǹ  ȣ ԷѴ
global blackkeys
set blackkeys {2 4 7 9 11 14 16 19 21 23 26 28 31 33 35}
#  ǹݵ Ͼ ǹݺ  ̰ Ѵ
foreach bk $blackkeys {.fc.c raise $bk}

#  
frame .f2
grid .f2 -padx 10 -pady 0
scale .f2.s1 -label "()" -font {fixed 9} -orient horizontal \
                        -from 0.2 -to 5 -resolution 0.2 -variable len
scale .f2.s2 -label "" -font {fixed 9} -orient horizontal \
                        -from 0 -to 100 -variable volume
scale .f2.s3 -label "" -font {fixed 9} -orient horizontal \
                        -from 0 -to 0.9 -resolution 0.1 -variable tone
grid .f2.s1 .f2.s2 .f2.s3

# Ҹ   ntot 20000 = 1̹Ƿ $len 20000 Ѵ
set len 1
# Ҹ   $volume * 150 Ѵ
set volume 20
set tone 0.5

# ޴ 
frame .f0
grid .f0  -padx 10 -pady 0

button .f0.b1 -text "" -width 10 -font {fixed 10} -command {mksnd}
button .f0.b2 -text " " -width 10 -font {fixed 10} -command {clrchd}
button .f0.b3 -text " ϱ" -width 10 -font {fixed 10} \
                                                    -command {choosecolor}
button .f0.b4 -text "̷п" -width 10 -font {fixed 10} -command {intervals}
button .f0.b5 -text "" -width 10 -font {fixed 10} -command {helpmsg}
grid .f0.b1 -row 0 -column 0 -padx 5 -pady 5 
grid .f0.b2 -row 0 -column 1 -padx 5 -pady 5 
grid .f0.b3 -row 0 -column 2 -padx 5 -pady 5 
grid .f0.b4 -row 0 -column 3 -padx 5 -pady 5 
grid .f0.b5 -row 0 -column 4 -padx 5 -pady 5 

frame .f1
grid .f1 -padx 10 -pady 10

#  row  ̸, col ڵ ̸ 
set chdnames {"" "7" "maj7" "dim" "dim7" "aug" "aug7" \
                   "sus4" "7sus4" "m7b5" "6" "9" "m" "m7" "m6" "m9"}
set roots {C C# D D# E F F# G G# A A# B}

foreach rown {0 1 2 3 4 5 6 7 8 9 10 11} row $roots {
    foreach coln {0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15} col $chdnames {
        set bno [expr $rown * [llength $chdnames] + $coln]
        button .f1.b$bno -text $row$col -width 6 -font {fixed 9} \
                                         -command "srchnt $bno $rown $coln"
        grid .f1.b$bno -row $rown -column $coln -padx 1 -pady 1
    }
}

# ư Ʈũ⸦ 9  
label .f1.l1 -text "ٸ ǥ:" -width 107 -font {fixed 10} -anchor w
label .f1.l2 -text " :" -width 107 -font {fixed 10} -anchor w
# ư Ʈũ⸦ 10 Ҷ
#label .f1.l1 -text "ٸ ǥ:" -width 118 -font {fixed 10} -anchor w
#label .f1.l2 -text " :" -width 118 -font {fixed 10} -anchor w

grid .f1.l1 -columnspan 16 -row 13 -column 0
grid .f1.l2 -columnspan 16 -row 14 -column 0

#  ǹ 迡 شϴ ļ Ͽ Ʈ freqs Ѵ
set freqs {}
for {set i 3} {$i <= 12} {incr i} {
    lappend freqs [expr 220 * pow(2, $i/12.0)]
}
for {set i 1} {$i <= 12} {incr i} {
    lappend freqs [expr 440 * pow(2, $i/12.0)]
}
for {set i 1} {$i <= 12} {incr i} {
    lappend freqs [expr 880 * pow(2, $i/12.0)]
}
for {set i 1} {$i <= 2} {incr i} {
    lappend freqs [expr 1760 * pow(2, $i/12.0)]
}

if [file exists [file join $inidir chord.ini]] {
    loadini
}

#  othernames comments θ
source [file join $appdir comments.dat]



